	SUBROUTINE DO_XYLIN_REGRID( cx_lims, src, msrc, dst, mdst,
     .				    work, src_cx, dst_cx, 
     .				    iwork2, iwork3, iwork4, iwork5, 
     .				    itot )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration''s (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* call the xy-linear regridding routine with appropriate work arrays
* 

* programmer - Ansley Manke, from do_xyave_regrid.F
* NOAA/PMEL, Seattle, WA - TMAP
*
* 6/22/2011
*                    The XY linear regridding matches past Ferret behavior, 
*                    not using bilinear regridding for now
*        2/12 *kms* Add E and F dimensions (use nferdims in tmap_dims.parm)
* V702 *sh* 3/2017 Dynamic memory revealed a bug in work array sizes
*  NOTE!!:  The logic for providing work arrays to this routine and its cousins
*           is a legacy of the bad-old days when there was only a single work
*           array.  Various starting indices into that array were passed
*           to XYLIN_REGRID as distinct work arrays.  Now that we have true
*           dynamic memory we could simplify this code by allocating 5 separate
*	    work arrays.  Or not ...

        IMPLICIT NONE
        include 'tmap_dims.parm'
	include	'ferret.parm'
	include	'xcontext.cmn'

* calling argument declarations:
	INTEGER	cx_lims, axis, msrc, mdst, iwork2, iwork3, iwork4, iwork5,
     .          itot, src_cx, dst_cx
	REAL	src(*), dst(*), work(itot)

	CALL XYLIN_REGRID( cx_lims,
     .			   cx_lo_ss(cx_lims,x_dim), cx_hi_ss(cx_lims,x_dim),
     .			   cx_lo_ss(cx_lims,y_dim), cx_hi_ss(cx_lims,y_dim),
     .			   src, msrc, dst, mdst, src_cx, dst_cx, 
     .			   cx_lo_ss(src_cx, x_dim), cx_hi_ss(src_cx, x_dim),
     .                     work(1), work(iwork2), work(iwork3), work(iwork4),
     .                     work(iwork5) )

	RETURN
	END
