	SUBROUTINE COPY_AGG_INTO_SUB( aloc, cxlo, cxhi, agg_dim,
     .          src, slox, shix, sloy, shiy, sloz, shiz, 
     .          slot, shit, sloe, shie, slof, shif,
     .          dst, dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .          dlot, dhit, dloe, dhie, dlof, dhif, 
     .          bad_src, bad_dst   )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* copy data from source grid into dstination grid using limits of source
* context (i.e. dstination grid is ASSUMED) big enough to hold data.
* Copy the ensemble member into e-axis location pointed to
* by index aloc.
*
* programmer - Ansley Manke
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program
*
* V680 5/12 *acm* 6D Ferret, changes for DEFINE DATA/AGGREGATE
* V695 2/15 *acm* 6D add aggregation in forecast direction
*
	include 'ferret.parm'

* calling argument declarations:
	INTEGER aloc, cxlo(*), cxhi(*),  agg_dim,
     .		slox, shix, sloy, shiy, sloz, shiz, 
     .          slot, shit, sloe, shie, slof, shif, 
     .          dlox, dhix, dloy, dhiy, dloz, dhiz, 
     .          dlot, dhit, dloe, dhie, dlof, dhif

	REAL    src( slox:shix,sloy:shiy,sloz:shiz,slot:shit,sloe:shie,slof:shif ),
     .          dst( dlox:dhix,dloy:dhiy,dloz:dhiz,dlot:dhit,dloe:dhie,dlof:dhif ),
     .          bad_src, bad_dst


* internal variable declarations:
	INTEGER	i, j, k, l, m, n

* --- end of introductory code ---

	IF (agg_dim .EQ. e_dim) THEN
	   m = cxlo(e_dim)
           DO 100 n = cxlo(6), cxhi(6)
	   DO 100 l = cxlo(4), cxhi(4)
	   DO 100 k = cxlo(3), cxhi(3)
	   DO 100 j = cxlo(2), cxhi(2)
	   DO 100 i = cxlo(1), cxhi(1)

	      IF (src(i,j,k,l,m,n) .NE. bad_src) THEN
	         dst(i,j,k,l,aloc,n) = src(i,j,k,l,m,n)
	      ELSE
	         dst(i,j,k,l,aloc,n) = bad_dst
	      ENDIF

 100	   CONTINUE
	ENDIF
	
	IF (agg_dim .EQ. f_dim) THEN
	   n = cxlo(f_dim)
           DO 200 m = cxlo(5), cxhi(5)
	   DO 200 l = cxlo(4), cxhi(4)
	   DO 200 k = cxlo(3), cxhi(3)
	   DO 200 j = cxlo(2), cxhi(2)
	   DO 200 i = cxlo(1), cxhi(1)

	      IF (src(i,j,k,l,m,n) .NE. bad_src) THEN
	         dst(i,j,k,l,m,aloc) = src(i,j,k,l,m,n)
	      ELSE
	         dst(i,j,k,l,m,aloc) = bad_dst
	      ENDIF

 200	   CONTINUE
	ENDIF

	RETURN
	END 
