	LOGICAL FUNCTION ITS_FMRC( grid )

*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* is the grid indicative of an FMRC variable
* True if both the T and F axes exist and have units of time 



* V695+ *sh* 4/15

* calling argument declarations
	INTEGER	grid

* internal variable declarations
	INTEGER tline, fline
* none

	include	'tmap_dims.parm'
	include 'ferret.parm'
	include 'xtm_grid.cmn_text'
	

	tline = grid_line(t_dim, grid)
	fline = grid_line(f_dim, grid)

	ITS_FMRC =
     .	     tline .NE. mnormal
     . .AND. fline .NE. mnormal
     . .AND. line_name(tline) .NE. 'ABSTRACT'
     . .AND. line_name(fline) .NE. 'ABSTRACT'
     . .AND. line_unit_code(tline) .LT. 0
     . .AND. line_unit_code(fline) .LT. 0
     . .AND. line_direction(tline)(1:1) .EQ. 'T'
     . .AND. line_direction(fline)(1:1) .EQ. 'F'

	RETURN
	END
