	SUBROUTINE EZ_INIT_PERMUTE(varnum )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* work routine for EZ_READ when /ORDER is not the default X-Y-Z-T
* Initialize the variables used to translate the permuted subscripts
* into the 1D array index

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Thermal Modeling and Analysis Program

* revision 0.00 -  5/94 *sh*
* Linux port -kob - 3/97 - Modify include for tmap_dset.parm to be a
*			   preprocessor include for F90 - needed because
*			   tmap_dset.parm contains an ifdef
* V674 2/12 *acm* 6D Ferret: use nferdims rather than 4 for dimension indexing

* calling arguments:
* varnum - the variable number in COMMON
	INTEGER varnum

        include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
        include 'xtm_grid.cmn_text'
        include 'xdset_info.cmn_text'
        include 'xez_order.cmn_text'

* local variable definitions:
	INTEGER idim, gridnum, line

* initialize
	gridnum = ds_grid_number(varnum)

* ezii    - the "current" subscript, zero referenced
* ezorder - the permuted ordering
* eznn    - the length of each axis
	DO 100 idim = 1, nferdims
	   ezii(idim) = 0
	   ezorder(idim) = ds_ordering(idim, varnum)
	   line = grid_line(idim, gridnum)
	   IF ( line .EQ. mpsnorm) THEN
	      eznn(idim) = 1
	   ELSE
	      eznn(idim) = line_dim(line)
	   ENDIF
 100	CONTINUE

* decrement by 1 since EZ_READ pre-increments
	ezii(ezorder(1)) = ezii(ezorder(1)) - 1
	RETURN
        END
