	SUBROUTINE TM_re_allo_tmp_line( line )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 

* The input line is currently stored in the tmp linked list.
* This routine shifts it to the dynamic line list.

* Steve Hankin  NOAA/PMEL/TMAP

* V510 *sh* 3/00
* V6.74 3/12 *acm* cleanup ifdefs and unnecessary include files

* Include files
	include 'tmap_dims.parm'
#include "tmap_dset.parm"
#include "gt_lib.parm"
	include 'tmap_errors.parm'
	include 'xtm_grid.cmn_text'
	external xgt_grid_data
	include 'xio.cmn_text'

* Argument definitions
	INTEGER line

* Local definitions
	INTEGER next_used_line,  next_free_line 

* it is not necessary to do this in 2 stages, but it was simpler --
* just hacked from well-tested code

* take this line from the "tmp" list and put it on the "free" list
* ... hook onto free list
	   next_used_line   = line_flink(line)
	   line_flink(line) = line_free_ptr  
	   line_free_ptr    = line
	   
* ... unhook from used list
	   line_flink(line_blink(line)) = next_used_line
	   line_blink(next_used_line)   = line_blink(line)

* take off the "free" list and put it at the start of the "used" list
* ... unhook from free list
	   next_free_line  	= line_flink(line)
	   line_free_ptr	= next_free_line
* ... hook onto front of used list
	   line_flink(line)	 = line_flink(max_lines)
	   line_blink(line)	 = max_lines
	   line_flink(max_lines) = line
	   line_blink(line_flink(line))	= line

	RETURN
	END

